Index: issm/trunk/src/c/cores/transient_core.cpp
===================================================================
--- issm/trunk/src/c/cores/transient_core.cpp	(revision 23389)
+++ issm/trunk/src/c/cores/transient_core.cpp	(revision 23394)
@@ -70,5 +70,5 @@
 	if(numoutputs) femmodel->parameters->FindParam(&requested_outputs,&numoutputs,TransientRequestedOutputsEnum);
 
-	#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+	#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 	if(amr_frequency){
 		femmodel->parameters->FindParam(&amr_restart,AmrRestartEnum);
@@ -78,5 +78,5 @@
 
 	if(isoceancoupling){ /*{{{*/
-		#ifndef _HAVE_ADOLC_
+		#ifndef _HAVE_AD_
 		if(VerboseSolution()) _printf0_("   ocean coupling: initialization \n");
 		int my_rank;
@@ -180,5 +180,5 @@
 		for(int i=0;i<ngrids_ocean;i++) if(icemask_oceangrid[i]>0.) icebase_oceangrid[i]=+9999.;
 		xDelete<IssmDouble>(icemask_oceangrid);
-			
+
 		if(my_rank==0){
 			ISSM_MPI_Send(icebase_oceangrid,ngrids_ocean,ISSM_MPI_DOUBLE,0,10001008,tomitgcmcomm);
@@ -247,5 +247,5 @@
 		if(isoceancoupling){ /*{{{*/
 
-			#ifndef _HAVE_ADOLC_
+			#ifndef _HAVE_AD_
 			if(VerboseSolution()) _printf0_("   ocean coupling: exchanging information\n");
 			int my_rank;
@@ -371,10 +371,12 @@
 				femmodel->parameters->FindParam(&smb_model,SmbEnum);
 				if(isenthalpy){
-					if(smb_model==SMBpddEnum)     ResetBoundaryConditions(femmodel,EnthalpyAnalysisEnum);
-					if(smb_model==SMBd18opddEnum) ResetBoundaryConditions(femmodel,EnthalpyAnalysisEnum);
+					if(smb_model==SMBpddEnum)				ResetBoundaryConditions(femmodel,EnthalpyAnalysisEnum);
+					if(smb_model==SMBd18opddEnum)			ResetBoundaryConditions(femmodel,EnthalpyAnalysisEnum);
+					if(smb_model==SMBpddSicopolisEnum)	ResetBoundaryConditions(femmodel,EnthalpyAnalysisEnum);
 				}
 				else{
-					if(smb_model==SMBpddEnum)     ResetBoundaryConditions(femmodel,ThermalAnalysisEnum);
-					if(smb_model==SMBd18opddEnum) ResetBoundaryConditions(femmodel,ThermalAnalysisEnum);
+					if(smb_model==SMBpddEnum)				ResetBoundaryConditions(femmodel,ThermalAnalysisEnum);
+					if(smb_model==SMBd18opddEnum)			ResetBoundaryConditions(femmodel,ThermalAnalysisEnum);
+					if(smb_model==SMBpddSicopolisEnum)	ResetBoundaryConditions(femmodel,ThermalAnalysisEnum);
 				}
 			}
@@ -382,4 +384,7 @@
 		}
 
+		/*shifting smb position to have runoff value*/
+		if(issmb) smb_core(femmodel);
+
 		if(ishydrology) hydrology_core(femmodel);
 
@@ -391,6 +396,5 @@
 
 		/* from here on, prepare geometry for next time step*/
-
-		if(issmb) smb_core(femmodel);
+		//if(issmb) smb_core(femmodel);
 
 		if(ismasstransport){
@@ -401,4 +405,8 @@
 
 		if(isgroundingline){
+
+			/*Start profiler*/
+			femmodel->profiler->Start(GROUNDINGLINECORE);
+
 			if(VerboseSolution()) _printf0_("   computing new grounding line position\n");
 			GroundinglineMigrationx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
@@ -410,4 +418,7 @@
 			femmodel->parameters->SetParam(SurfaceEnum,InputToExtrudeEnum);
 			extrudefrombase_core(femmodel);
+
+			/*Stop profiler*/
+			femmodel->profiler->Stop(GROUNDINGLINECORE);
 
 			if(save_results){
@@ -453,5 +464,5 @@
 		if(amr_frequency){
 
-			#if !defined(_HAVE_ADOLC_)
+			#if !defined(_HAVE_AD_)
 			if(save_results) femmodel->WriteMeshInResults();
 			if(step%amr_frequency==0 && time<finaltime){
@@ -461,5 +472,5 @@
 
 			#else
-			_error_("AMR not suppored with ADOLC");
+			_error_("AMR not suppored with AD");
 			#endif
 		}
Index: issm/trunk/src/c/modules/CoordinateSystemTransformx/CoordinateSystemTransformx.cpp
===================================================================
--- issm/trunk/src/c/modules/CoordinateSystemTransformx/CoordinateSystemTransformx.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/CoordinateSystemTransformx/CoordinateSystemTransformx.cpp	(revision 23394)
@@ -9,5 +9,5 @@
 #include <proj_api.h>
 
-void CoordinateSystemTransformx(IssmDouble** px_dest,IssmDouble** py_dest,IssmDouble* x_src,IssmDouble* y_src,int size,const char* str_src,const char* str_dst){
+void CoordinateSystemTransformx(double** px_dest,double** py_dest,double* x_src,double* y_src,int size,const char* str_src,const char* str_dst){
 
 #if !defined(_HAVE_PROJ4_)
@@ -17,6 +17,6 @@
 	/*Allocate output and initialize values as src*/
 	_assert_(size>0);
-	IssmDouble* x_dest = xNew<IssmDouble>(size);
-	IssmDouble* y_dest = xNew<IssmDouble>(size);
+	double* x_dest = xNew<double>(size);
+	double* y_dest = xNew<double>(size);
 	for(int i=0;i<size;i++){
 		x_dest[i] = x_src[i];
Index: issm/trunk/src/c/modules/CoordinateSystemTransformx/CoordinateSystemTransformx.h
===================================================================
--- issm/trunk/src/c/modules/CoordinateSystemTransformx/CoordinateSystemTransformx.h	(revision 23389)
+++ issm/trunk/src/c/modules/CoordinateSystemTransformx/CoordinateSystemTransformx.h	(revision 23394)
@@ -8,4 +8,4 @@
 
 /* local prototypes: */
-void CoordinateSystemTransformx(IssmDouble** px_dest,IssmDouble** py_dest,IssmDouble* x_src,IssmDouble* y_src,int size,const char* str_src,const char* str_dst);
+void CoordinateSystemTransformx(double** px_dest,double** py_dest,double* x_src,double* y_src,int size,const char* str_src,const char* str_dst);
 #endif  
Index: issm/trunk/src/c/modules/FloatingiceMeltingRatePicox/FloatingiceMeltingRatePicox.cpp
===================================================================
--- issm/trunk/src/c/modules/FloatingiceMeltingRatePicox/FloatingiceMeltingRatePicox.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/FloatingiceMeltingRatePicox/FloatingiceMeltingRatePicox.cpp	(revision 23394)
@@ -78,5 +78,6 @@
 		IssmDouble val=sqrt(dmax_basin[i]/dist_max)*(maxbox-1);
 
-		#ifdef _HAVE_ADOLC_
+		#ifdef _HAVE_AD_
+		_error_("Check the implementation of floor below");
 		/*Do not use floor when AD is on*/
 		int k=0; while(k<val+.5){k++;}
Index: issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.cpp
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.cpp	(revision 23394)
@@ -78,49 +78,26 @@
 
 }/*}}}*/
-void GetVectorFromControlInputsx( IssmDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, const char* data){/*{{{*/
+void GetVectorFromControlInputsx( IssmDouble** pvector,int *pN, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, const char* data){/*{{{*/
 
 	/*intermediary: */
+	int                 N;
 	Vector<IssmDouble>* vec_vector=NULL;
 
+	/*Get PETSc vector*/
 	GetVectorFromControlInputsx( &vec_vector, elements,nodes, vertices, loads, materials, parameters,data);
+
+	/*Serialize*/
+	vec_vector->GetSize(&N);
 	IssmDouble* vector=vec_vector->ToMPISerial();
-
-	/*Free ressources:*/
 	delete vec_vector;
 
 	/*Assign output pointers:*/
 	*pvector=vector;
+	if(pN) *pN=N;
 }/*}}}*/
 
 /*For autodiff, we sometimes need to cast our vectors to passive*/
-#ifdef _HAVE_ADOLC_
-void GetPassiveVectorFromControlInputsx(Vector<IssmPDouble>** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,const char* data){/*{{{*/
-
-	/*Get active vector first*/
-	Vector<IssmDouble>*   activevector=NULL;
-	Vector<IssmPDouble>*  vector=NULL;
-	int                   size;
-
-	/*Retrieve some parameters*/
-	GetVectorFromControlInputsx(&activevector, elements,nodes, vertices, loads, materials, parameters,data);
-
-	/*Serialize vector*/
-	activevector->GetSize(&size);
-	IssmDouble* dactivevector=activevector->ToMPISerial();
-
-	/*Cast to passive*/
-	vector=new Vector<IssmPDouble>(size);
-	for(int i=0;i<size;i++){
-		vector->SetValue(i,reCast<IssmPDouble>(dactivevector[i]),INS_VAL);
-	}
-	vector->Assemble();
-
-	/*Assign output pointers:*/
-	delete activevector;
-	xDelete<IssmDouble>(dactivevector);
-	*pvector=vector;
-
-}/*}}}*/
-void GetPassiveVectorFromControlInputsx(IssmPDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, const char* data){/*{{{*/
+#ifdef _HAVE_AD_
+void GetPassiveVectorFromControlInputsx(IssmPDouble** pvector,int* pN, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, const char* data){/*{{{*/
 
 	/*Get active vector first*/
@@ -144,15 +121,11 @@
 	xDelete<IssmDouble>(dactivevector);
 	*pvector=vector;
+	if(pN) *pN=size;
 
 }/*}}}*/
 #else
-void GetPassiveVectorFromControlInputsx(Vector<IssmPDouble>** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,const char* data){/*{{{*/
+void GetPassiveVectorFromControlInputsx(IssmPDouble** pvector,int* pN, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, const char* data){/*{{{*/
 
-	GetVectorFromControlInputsx(pvector, elements,nodes, vertices, loads, materials, parameters,data);
-
-}/*}}}*/
-void GetPassiveVectorFromControlInputsx(IssmPDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, const char* data){/*{{{*/
-
-	GetVectorFromControlInputsx(pvector, elements,nodes, vertices, loads, materials, parameters,data);
+	GetVectorFromControlInputsx(pvector,pN,elements,nodes, vertices, loads, materials, parameters,data);
 }/*}}}*/
 #endif
Index: issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.h
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.h	(revision 23389)
+++ issm/trunk/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.h	(revision 23394)
@@ -9,8 +9,7 @@
 /* local prototypes: */
 void	GetVectorFromControlInputsx( Vector<IssmDouble>** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
-void	GetVectorFromControlInputsx( IssmDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
+void	GetVectorFromControlInputsx( IssmDouble** pvector,int* pN, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
 
-void	GetPassiveVectorFromControlInputsx(Vector<double>** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
-void	GetPassiveVectorFromControlInputsx(double** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
+void	GetPassiveVectorFromControlInputsx(double** pvector,int* pN, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,const char* data="value");
 
 #endif  /* _GETVECTORFROMCONTROLINPUTSXX_H */
Index: issm/trunk/src/c/modules/ModelProcessorx/Autodiff/CreateParametersAutodiff.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Autodiff/CreateParametersAutodiff.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/ModelProcessorx/Autodiff/CreateParametersAutodiff.cpp	(revision 23394)
@@ -73,7 +73,36 @@
 		xDelete<char>(options);
 		/*}}}*/
+		#elif _HAVE_CODIPACK_
+		//fprintf(stderr, "*** Codipack CreateParametersAutodiff()\n");
+		/*initialize a placeholder to store solver pointers: {{{*/
+		/*Solver pointers depend on what type of solver we are implementing: */
+		options=OptionsFromAnalysis(&toolkit,parameters,DefaultAnalysisEnum);
+		ToolkitOptions::Init(toolkit,options);
+		xDelete<char>(toolkit);
+
+		switch(IssmSolverTypeFromToolkitOptions()){
+			case MumpsEnum:{
+				#ifndef _HAVE_MUMPS_
+				_error_("CoDiPack: requesting mumps solver without MUMPS being compiled in!");
+				#endif
+				break;
+				}
+			case GslEnum: {
+				#ifndef _HAVE_GSL_
+				_error_("CoDiPack: requesting GSL solver without GSL being compiled in!");
+				#endif
+				break;
+				}
+			default:
+							_error_("solver type not supported yet!");
+		}
+		/*Free ressources: */
+		xDelete<char>(options);
+		#endif
+		#if defined(_HAVE_AD_) 
 
 	if(isautodiff){
-		/*Copy some parameters from IoModel to parameters dataset: {{{*/
+		#if defined(_HAVE_ADOLC_)
+		/*Copy some parameters from IoModel to parameters dataset*/
 		parameters->AddObject(iomodel->CopyConstantObject("md.autodiff.obufsize",AutodiffObufsizeEnum));
 		parameters->AddObject(iomodel->CopyConstantObject("md.autodiff.cbufsize",AutodiffCbufsizeEnum));
@@ -82,5 +111,12 @@
 		parameters->AddObject(iomodel->CopyConstantObject("md.autodiff.gcTriggerRatio",AutodiffGcTriggerRatioEnum));
 		parameters->AddObject(iomodel->CopyConstantObject("md.autodiff.gcTriggerMaxSize",AutodiffGcTriggerMaxSizeEnum));
-		/*}}}*/
+
+		#elif defined(_HAVE_CODIPACK_)
+		parameters->AddObject(iomodel->CopyConstantObject("md.autodiff.tapeAlloc",AutodiffTapeAllocEnum));
+
+		#else
+		_error_("not supported yet");
+		#endif
+
 		/*retrieve driver: {{{*/
 		iomodel->FindConstant(&autodiff_driver,"md.autodiff.driver");
@@ -88,4 +124,8 @@
 
 		if(strcmp(autodiff_driver,"fos_forward")==0){
+#if _HAVE_CODIPACK_
+			// FIXME codi support Foward Mode (scalar)
+			_error_("Foward Mode (scalar) not supported yet!");
+#endif
 			parameters->AddObject(iomodel->CopyConstantObject("md.autodiff.fos_forward_index",AutodiffFosForwardIndexEnum));
 		}
@@ -94,4 +134,8 @@
 		}
 		else if(strcmp(autodiff_driver,"fov_forward")==0){
+#if _HAVE_CODIPACK_
+			// FIXME codi support Foward Mode (vector)
+			_error_("Foward Mode (vector) not supported yet!");
+#endif
 			/*Retrieve list of indices: */
 			iomodel->FetchData(&indices,&num_indices,&dummy,"md.autodiff.fov_forward_indices");
Index: issm/trunk/src/c/modules/ModelProcessorx/Control/UpdateElementsAndMaterialsControl.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Control/UpdateElementsAndMaterialsControl.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/ModelProcessorx/Control/UpdateElementsAndMaterialsControl.cpp	(revision 23394)
@@ -9,5 +9,4 @@
 #include "../ModelProcessorx.h"
 
-#if !defined(_HAVE_ADOLC_)
 void	UpdateElementsAndMaterialsControl(Elements* elements,Parameters* parameters,Materials* materials, IoModel* iomodel){
 	/*Intermediary*/
@@ -20,4 +19,12 @@
 	char     **controls         = NULL;
 	char     **cost_functions   = NULL;
+
+	/*Fetch parameters: */
+	bool isautodiff;
+	iomodel->FindConstant(&isautodiff,"md.autodiff.isautodiff");
+	if(isautodiff){
+		UpdateElementsAndMaterialsControlAD(elements,parameters,materials,iomodel);
+		return;
+	}
 
 	/*Fetch parameters: */
@@ -126,7 +133,7 @@
 	xDelete<char*>(controls);
 }
-#else 
-void UpdateElementsAndMaterialsControl(Elements* elements,Parameters* parameters,Materials* materials, IoModel* iomodel){
-
+void UpdateElementsAndMaterialsControlAD(Elements* elements,Parameters* parameters,Materials* materials, IoModel* iomodel){
+
+	#if defined(_HAVE_AD_)
 	/*Intermediaries*/
 	int				num_independent_objects,M,N,M_par,N_par;
@@ -222,7 +229,10 @@
 	xDelete<IssmDouble>(independents_fullmax);
 	xDelete<int>(start_point);
+	xDelete<int>(control_sizes);
 	/*Step2: create cost functions (dependents)*/
 
 	return;
+#else 
+	_error_("AD not compiled");
+#endif
 }
-#endif
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateNodes.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateNodes.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateNodes.cpp	(revision 23394)
@@ -32,5 +32,5 @@
 				for(j=0;j<3;j++){
 					if(my_nodes[3*i+j]){ 
-						nodes->AddObject(new Node(id0+3*i+j+1,id0+3*i+j,lid++,iomodel->elements[+3*i+j]-1,iomodel,analysis,approximation));
+						nodes->AddObject(new Node(id0+3*i+j+1,id0+3*i+j,lid++,iomodel->elements[3*i+j]-1,iomodel,analysis,approximation));
 
 					}
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 23394)
@@ -374,5 +374,5 @@
 	ParseToolkitsOptionsx(parameters,toolkitsoptionsfid);
 
-	#ifdef _HAVE_ADOLC_
+	#ifdef _HAVE_AD_
 	if(VerboseMProcessor()) _printf0_("   starting autodiff parameters \n");
 	CreateParametersAutodiff(parameters,iomodel);
Index: issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.h
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.h	(revision 23389)
+++ issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.h	(revision 23394)
@@ -19,4 +19,5 @@
 void CreateOutputDefinitions(Elements* elements, Parameters* parameters,IoModel* iomodel);
 void UpdateElementsAndMaterialsControl(Elements* elements,Parameters* parameters,Materials* materials, IoModel* iomodel);
+void UpdateElementsAndMaterialsControlAD(Elements* elements,Parameters* parameters,Materials* materials, IoModel* iomodel);
 void UpdateElementsAndMaterialsDakota(Elements* elements,Materials* materials, IoModel* iomodel);
 void UpdateElementsTransient(Elements* elements,Parameters* parameters,IoModel* iomodel,int analysis_type);
Index: issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp
===================================================================
--- issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp	(revision 23394)
@@ -33,4 +33,6 @@
 
 		xDelete<int>(control_type);
+		xDelete<int>(M);
+		xDelete<int>(N);
 	}
 	else{
Index: issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp	(revision 23394)
@@ -62,5 +62,5 @@
 	//into specified top structure depth (zTop). Also make sure top grid cell
 	//structure length (dzTop) is greater than 5 cm
-	#ifndef _HAVE_ADOLC_  //avoid the round operation check!
+	#ifndef _HAVE_AD_  //avoid the round operation check!
 	if (dgpTop != round(dgpTop)){ 
 		_error_("top grid cell structure length does not go evenly into specified top structure depth, adjust dzTop or zTop");
@@ -425,9 +425,9 @@
 			// spectral range:
 			// 0.3 - 0.8um
-			IssmDouble a0 = fmin(0.98, 1 - 1.58 *pow(gsz,0.5));
+			IssmDouble a0 = min(0.98, 1 - 1.58 *pow(gsz,0.5));
 			// 0.8 - 1.5um
-			IssmDouble a1 = fmax(0, 0.95 - 15.4 *pow(gsz,0.5));
+			IssmDouble a1 = max(0., 0.95 - 15.4 *pow(gsz,0.5));
 			// 1.5 - 2.8um
-			IssmDouble a2 = fmax(0.127, 0.88 + 346.3*gsz - 32.31*pow(gsz,0.5));
+			IssmDouble a2 = max(0.127, 0.88 + 346.3*gsz - 32.31*pow(gsz,0.5));
 
 			// broadband surface albedo
@@ -667,5 +667,5 @@
 	// NS: 2.16.18 divided dt by scaling factor, default set to 1/11 for stability
 	dt=1e12; 
-	for(int i=0;i<m;i++)dt = fmin(dt,CI * pow(dz[i],2) * d[i]  / (3 * K[i]) * thermo_scaling);
+	for(int i=0;i<m;i++)dt = min(dt,CI * pow(dz[i],2) * d[i]  / (3 * K[i]) * thermo_scaling);
 
 	// smallest possible even integer of 60 min where diffusion number > 1/2
@@ -752,5 +752,5 @@
 		// less when Ts is taken as the mean of the x top grid cells.
 		Ts = (T[0] + T[1])/2.0;
-		Ts = fmin(CtoK,Ts);    // don't allow Ts to exceed 273.15 K (0 degC)
+		Ts = min(CtoK,Ts);    // don't allow Ts to exceed 273.15 K (0 degC)
 
 		//TURBULENT HEAT FLUX
@@ -767,5 +767,5 @@
 
 		// do not allow Ri to exceed 0.19
-		Ri = fmin(Ri, 0.19);
+		Ri = min(Ri, 0.19);
 
 		// calculate momentum 'coefM' stability factor
@@ -947,9 +947,9 @@
 			// spectral albedos:
 			// 0.3 - 0.8um
-			IssmDouble a0 = fmin(0.98, 1.0 - 1.58 *pow(gsz[0],0.5));
+			IssmDouble a0 = min(0.98, 1.0 - 1.58 *pow(gsz[0],0.5));
 			// 0.8 - 1.5um
-			IssmDouble a1 = fmax(0.0, 0.95 - 15.4 *pow(gsz[0],0.5));
+			IssmDouble a1 = max(0.0, 0.95 - 15.4 *pow(gsz[0],0.5));
 			// 1.5 - 2.8um
-			IssmDouble a2 = fmax(0.127, 0.88 + 346.3*gsz[0] - 32.31*pow(gsz[0],0.5));
+			IssmDouble a2 = max(0.127, 0.88 + 346.3*gsz[0] - 32.31*pow(gsz[0],0.5));
 
 			// separate net shortwave radiative flux into spectral ranges
@@ -1204,5 +1204,5 @@
 		mass_diff = mass - massinit - P;
 
-		#ifndef _HAVE_ADOLC_  //avoid round operation. only check in forward mode.
+		#ifndef _HAVE_AD_  //avoid round operation. only check in forward mode.
 		mass_diff = round(mass_diff * 100.0)/100.0;
 		if (mass_diff > 0) _error_("mass not conserved in accumulation function");
@@ -1323,9 +1323,9 @@
 	// calculate temperature excess above 0 deg C
 	exsT=xNewZeroInit<IssmDouble>(n);
-	for(int i=0;i<n;i++) exsT[i]= fmax(0.0, T[i] - CtoK);        // [K] to [degC]
+	for(int i=0;i<n;i++) exsT[i]= max(0.0, T[i] - CtoK);        // [K] to [degC]
 
 	// new grid point center temperature, T [K]
 	// for(int i=0;i<n;i++) T[i]-=exsT[i];
-	for(int i=0;i<n;i++) T[i]=fmin(T[i],CtoK);
+	for(int i=0;i<n;i++) T[i]=min(T[i],CtoK);
 
 	// specify irreducible water content saturation [fraction]
@@ -1337,8 +1337,8 @@
 		if(VerboseSmb() && sid==0 && IssmComm::GetRank()==0)_printf0_("      pore water refreeze\n");
 		// calculate maximum freeze amount, maxF [kg]
-		for(int i=0;i<n;i++) maxF[i] = fmax(0.0, -((T[i] - CtoK) * m[i] * CI) / LF);
+		for(int i=0;i<n;i++) maxF[i] = max(0.0, -((T[i] - CtoK) * m[i] * CI) / LF);
 
 		// freeze pore water and change snow/ice properties
-		for(int i=0;i<n;i++) dW[i] = fmin(maxF[i], W[i]);    // freeze mass [kg]   
+		for(int i=0;i<n;i++) dW[i] = min(maxF[i], W[i]);    // freeze mass [kg]   
 		for(int i=0;i<n;i++) W[i] -= dW[i];                                            // pore water mass [kg]
 		for(int i=0;i<n;i++) m[i] += dW[i];                                            // new mass [kg]
@@ -1356,5 +1356,5 @@
 	for(int i=0;i<n;i++){
 		Wi= (dIce - d[i]) * Swi * (m[i] / d[i]);        // irreducible water content [kg]
-		exsW[i] = fmax(0.0, W[i] - Wi);                  // water "squeezed" from snow [kg]
+		exsW[i] = max(0.0, W[i] - Wi);                  // water "squeezed" from snow [kg]
 	}
 
@@ -1368,5 +1368,5 @@
 		// (maximum T of snow before entire grid cell melts is a constant
 		// LF/CI = 159.1342)
-		surpT=xNew<IssmDouble>(n); for(int i=0;i<n;i++)surpT[i] = fmax(0.0, exsT[i]- LF/CI);
+		surpT=xNew<IssmDouble>(n); for(int i=0;i<n;i++)surpT[i] = max(0.0, exsT[i]- LF/CI);
 
 		if (cellsum(surpT,n) > 0.0 + Ttol ){
@@ -1380,8 +1380,8 @@
 				T[i+1] = surpE[i]/m[i+1]/CI + T[i+1];
 
-				exsT[i+1] = fmax(0.0, T[i+1] - CtoK) + exsT[i+1];
-				T[i+1] = fmin(CtoK, T[i+1]);
-
-				surpT[i+1] = fmax(0.0, exsT[i+1] - LF/CI);
+				exsT[i+1] = max(0.0, T[i+1] - CtoK) + exsT[i+1];
+				T[i+1] = min(CtoK, T[i+1]);
+
+				surpT[i+1] = max(0.0, exsT[i+1] - LF/CI);
 				surpE[i+1] = surpT[i+1] * CI * m[i+1];
 
@@ -1394,9 +1394,9 @@
 
 		// convert temperature excess to melt [kg]
-		for(int i=0;i<n;i++) M[i] = fmin(exsT[i] * d[i] * dz[i] * CI / LF, m[i]);  // melt
+		for(int i=0;i<n;i++) M[i] = min(exsT[i] * d[i] * dz[i] * CI / LF, m[i]);  // melt
 		sumM = cellsum(M,n);                                                       // total melt [kg]
 
 		// calculate maximum refreeze amount, maxF [kg]
-		for(int i=0;i<n;i++)maxF[i] = fmax(0.0, -((T[i] - CtoK) * d[i] * dz[i] * CI)/ LF);
+		for(int i=0;i<n;i++)maxF[i] = max(0.0, -((T[i] - CtoK) * d[i] * dz[i] * CI)/ LF);
 
 		// initialize refreeze, runoff, flxDn and dW vectors [kg]
@@ -1435,6 +1435,6 @@
 				m[i] = m[i] - M[i];                     // mass after melt
 				Wi = (dIce-d[i]) * Swi * (m[i]/d[i]);    // irreducible water 
-				dW[i] = fmax(fmin(inM, Wi - W[i]),-1*W[i]);            // change in pore water
-				R[i] = fmax(0.0, inM - dW[i]);             // runoff
+				dW[i] = max(min(inM, Wi - W[i]),-1*W[i]);            // change in pore water
+				R[i] = max(0.0, inM - dW[i]);             // runoff
 				F[i] = 0.0;
 			}
@@ -1447,6 +1447,6 @@
 				m[i] = m[i] - M[i];                     // mass after melt
 				Wi = (dIce-d[i]) * Swi * (m[i]/d[i]);    // irreducible water 
-				dW[i] = fmax(fmin(inM, Wi - W[i]),-1*W[i]);              // change in pore water
-				flxDn[i+1] = fmax(0.0, inM - dW[i]);         // meltwater out
+				dW[i] = max(min(inM, Wi - W[i]),-1*W[i]);              // change in pore water
+				flxDn[i+1] = max(0.0, inM - dW[i]);         // meltwater out
 				R[i] = 0.0;
 				F[i] = 0.0;                               // no freeze 
@@ -1460,5 +1460,5 @@
 				IssmDouble dz_0 = m[i]/d[i];          
 				IssmDouble dMax = (dIce - d[i])*dz_0;              // d max = dIce
-				IssmDouble F1 = fmin(fmin(inM,dMax),maxF[i]);         // maximum refreeze               
+				IssmDouble F1 = min(min(inM,dMax),maxF[i]);         // maximum refreeze               
 				m[i] = m[i] + F1;                       // mass after refreeze
 				d[i] = m[i]/dz_0;
@@ -1466,5 +1466,5 @@
 				//-----------------------pore water-----------------------------
 				Wi = (dIce-d[i])* Swi * dz_0;            // irreducible water 
-				dW[i] = fmin(inM - F1, Wi-W[i]);         // change in pore water
+				dW[i] = min(inM - F1, Wi-W[i]);         // change in pore water
 				if (dW[i] < 0.0-Wtol && -1*dW[i]>W[i]-Wtol ){
 					dW[i]= -1*W[i];
@@ -1474,6 +1474,6 @@
 				if (dW[i] < 0.0-Wtol){                         // excess pore water
 					dMax = (dIce - d[i])*dz_0;          // maximum refreeze                                             
-					IssmDouble maxF2 = fmin(dMax, maxF[i]-F1);      // maximum refreeze
-					F2 = fmin(-1*dW[i], maxF2);            // pore water refreeze
+					IssmDouble maxF2 = min(dMax, maxF[i]-F1);      // maximum refreeze
+					F2 = min(-1*dW[i], maxF2);            // pore water refreeze
 					m[i] = m[i] + F2;                   // mass after refreeze
 					d[i] = m[i]/dz_0;
@@ -1753,5 +1753,5 @@
 
 	/*only in forward mode! avoid round in AD mode as it is not differentiable: */
-	#ifndef _HAVE_ADOLC_
+	#ifndef _HAVE_AD_
 	dm = round((mSum0 - mSum1 + mAdd)*100.0)/100.0;
 	dE = round(sumE0 - sumE1 - sumER +  addE);
@@ -1915,6 +1915,6 @@
 				c0arth = 0.07 * H;
 				c1arth = 0.03 * H;
-				M0 = fmax(1.435 - (0.151 * log(C)),0.25);
-				M1 = fmax(2.366 - (0.293 * log(C)),0.25);
+				M0 = max(1.435 - (0.151 * log(C)),0.25);
+				M1 = max(2.366 - (0.293 * log(C)),0.25);
 				c0 = M0*c0arth;
 				c1 = M1*c1arth;
@@ -1926,6 +1926,6 @@
 				c0arth = 0.07 * H;
 				c1arth = 0.03 * H;
-				M0 = fmax(1.042 - (0.0916 * log(C)),0.25);
-				M1 = fmax(1.734 - (0.2039 * log(C)),0.25);
+				M0 = max(1.042 - (0.0916 * log(C)),0.25);
+				M1 = max(1.734 - (0.2039 * log(C)),0.25);
 				c0 = M0*c0arth;
 				c1 = M1*c1arth;
@@ -2021,5 +2021,5 @@
 
 	// do not allow Ri to exceed 0.19
-	Ri = fmin(Ri, 0.19);
+	Ri = min(Ri, 0.19);
 
 	// calculate momentum 'coefM' stability factor
Index: issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.cpp	(revision 23389)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.cpp	(revision 23394)
@@ -1,4 +1,4 @@
 /*!\file SurfaceMassBalancex
- * \brief: calculates SMB 
+ * \brief: calculates SMB
  */
 
@@ -105,5 +105,5 @@
 		for(v=0;v<numvertices;v++){
 			// if surface is above the ELA
-			if(s[v]>ela[v]){		
+			if(s[v]>ela[v]){
 				smb[v]=b_pos[v]*(s[v]-ela[v]);
 			}
@@ -167,5 +167,5 @@
 	//    INPUT: surface elevation (m): hd(NA)
 	//    monthly mean surface sealevel temperature (degrees C): vTempsea(NA
-	//    ,NTIME) 
+	//    ,NTIME)
 	//    monthly mean precip rate (m/yr water equivalent): vPrec(NA,NTIME)
 	//    OUTPUT: mass-balance (m/yr ice): agd(NA)
@@ -174,5 +174,5 @@
 	int    i, it, jj, itm;
 	IssmDouble DT = 0.02, sigfac, snormfac;
-	IssmDouble signorm = 5.5;      // signorm : sigma of the temperature distribution for a normal day 
+	IssmDouble signorm = 5.5;      // signorm : sigma of the temperature distribution for a normal day
 	IssmDouble siglim;       // sigma limit for the integration which is equal to 2.5 sigmanorm
 	IssmDouble signormc = signorm - 0.5;     // sigma of the temperature distribution for cloudy day
@@ -180,5 +180,5 @@
 	IssmDouble tstep, tsint, tint, tstepc;
 	int    NPDMAX = 1504, NPDCMAX = 1454;
-	//IssmDouble pdds[NPDMAX]={0}; 
+	//IssmDouble pdds[NPDMAX]={0};
 	//IssmDouble pds[NPDCMAX]={0};
 	IssmDouble pddt, pd ; // pd : snow/precip fraction, precipitation falling as snow
@@ -193,6 +193,6 @@
 	Element    *element = NULL;
 
-	pdds=xNew<IssmDouble>(NPDMAX+1); 
-	pds=xNew<IssmDouble>(NPDCMAX+1); 
+	pdds=xNew<IssmDouble>(NPDMAX+1);
+	pds=xNew<IssmDouble>(NPDCMAX+1);
 
 	// Get ismungsm parameter
@@ -216,5 +216,5 @@
 
 	if(itm >= NPDMAX) _error_("increase NPDMAX in massBalance.cpp");
-	for(it = 0; it < itm; it++){  
+	for(it = 0; it < itm; it++){
 		//    tstar = REAL(it)*DT-siglim;
 		tstar = it*DT-siglim;
@@ -262,4 +262,15 @@
 	xDelete<IssmDouble>(pds);
 }/*}}}*/
+void PositiveDegreeDaySicopolisx(FemModel* femmodel){/*{{{*/
+
+	bool isfirnwarming;
+	femmodel->parameters->FindParam(&isfirnwarming,SmbIsfirnwarmingEnum);
+
+	for(int i=0;i<femmodel->elements->Size();i++){
+		Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		element->PositiveDegreeDaySicopolis(isfirnwarming);
+	}
+
+}/*}}}*/
 void SmbHenningx(FemModel* femmodel){/*{{{*/
 
@@ -346,7 +357,7 @@
 		/*Allocate all arrays*/
 		int         numvertices = element->GetNumberOfVertices();
-		IssmDouble* acc         = xNew<IssmDouble>(numvertices); 
+		IssmDouble* acc         = xNew<IssmDouble>(numvertices);
 		IssmDouble* evap        = xNew<IssmDouble>(numvertices);
-		IssmDouble* runoff      = xNew<IssmDouble>(numvertices); 
+		IssmDouble* runoff      = xNew<IssmDouble>(numvertices);
 		IssmDouble* smb         = xNew<IssmDouble>(numvertices);
 
@@ -388,5 +399,5 @@
 		int         numvertices = element->GetNumberOfVertices();
 		IssmDouble* acc         = xNew<IssmDouble>(numvertices);
-		IssmDouble* evap        = xNew<IssmDouble>(numvertices); 
+		IssmDouble* evap        = xNew<IssmDouble>(numvertices);
 		IssmDouble* melt        = xNew<IssmDouble>(numvertices);
 		IssmDouble* refreeze    = xNew<IssmDouble>(numvertices);
@@ -414,2 +425,15 @@
 
 }/*}}}*/
+void SmbGradientsComponentsx(FemModel* femmodel){/*{{{*/
+
+	// void SurfaceMassBalancex(hd,agd,ni){
+	//    INPUT parameters: ni: working size of arrays
+	//    INPUT: surface elevation (m): hd(NA)
+	//    OUTPUT: mass-balance (m/yr ice): agd(NA)
+
+	for(int i=0;i<femmodel->elements->Size();i++){
+		Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		element->SmbGradCompParameterization();
+	}
+
+}/*}}}*/
